#ifndef __EN_DBG_H
#define __EN_DBG_H

#ifdef SOURCE_TRACE
#if defined(__TURBOC__) || defined(M_I86) || defined(__WATCOMC__)
#define ENDL        Enc_dbg_line = __LINE__, Enc_dbg_file = __FILE__
#else
#ifdef __POWERC
#define ENDL        Enc_dbg_line = __LINE__
#else
#define ENDL        Enc_dbg_line = 0
#endif
#endif

/*------------------------------- com macros -------------------------------*/
#define com_tx_cnt(cp)            (ENDL,com_tx_cnt(cp))
#define com_rx_cnt(cp)            (ENDL,com_rx_cnt(cp))
#define com_tx_free(cp)           (ENDL,com_tx_free(cp))
#define com_rx_free(cp)           (ENDL,com_rx_free(cp))
#define is_rx_empty(cp)           (ENDL,is_rx_empty(cp))
#define is_rx_full(cp)            (ENDL,is_rx_full(cp))
#define is_tx_empty(cp)           (ENDL,is_tx_empty(cp))
#define is_tx_full(cp)            (ENDL,is_tx_full(cp))

#define set_encrypt(c, cp)        (ENDL,set_encrypt(c, cp))
#define set_match(c, cp)          (ENDL,set_match(c, cp))
#define init_msg(cp)              (ENDL,init_msg(cp))

#define msg_cnt(cp)               (ENDL,msg_cnt(cp))
#define clear_msg_cnt(cp)         (ENDL,clear_msg_cnt(cp))

#define set_que_status(x,cp)      (ENDL,set_que_status(x,cp))
#define is_que_status(cp)         (ENDL,is_que_status(cp))

/*----------------------------- flow control -------------------------------*/
#define set_lowwater(l,cp)        (ENDL,set_lowwater(l,cp))
#define set_highwater(h,cp)       (ENDL,set_highwater(h,cp))
#define get_lowwater(cp)          (ENDL,get_lowwater(cp))
#define get_highwater(cp)         (ENDL,get_highwater(cp))

#define set_cts_flow(x,cp)        (ENDL,set_cts_flow(x,cp))

#define is_cts_flow(cp)           (ENDL,is_cts_flow(cp))
#define is_dcd_flow(cp)           (ENDL,is_dcd_flow(cp))
#define is_dsr_flow(cp)           (ENDL,is_dsr_flow(cp))
#define is_xon_flow(cp)           (ENDL,is_xon_flow(cp))

#define cts_flow_state(cp)        (ENDL,cts_flow_state(cp))
#define dcd_flow_state(cp)        (ENDL,dcd_flow_state(cp))
#define dsr_flow_state(cp)        (ENDL,dsr_flow_state(cp))
#define xon_flow_state(cp)        (ENDL,xon_flow_state(cp))

/*----------------------- 16550 fifo control macro -------------------------*/
#define fifo_enable(cp)           (ENDL,fifo_enable(cp))
#define fifo_disable(cp)          (ENDL,fifo_disable(cp))
#define fifo_rx_reset(cp)         (ENDL,fifo_rx_reset(cp))
#define fifo_tx_reset(cp)         (ENDL,fifo_tx_reset(cp))

#define is_fifo_enabled(cp)       (ENDL,is_fifo_enabled(cp))
#define get_trigger_level(cp)     (ENDL,get_trigger_level(cp))

/*------------------------------ modem macros ------------------------------*/
#define modem_reset(cp)           (ENDL,modem_reset(cp))
#define modem_dial(s,cp)          (ENDL,modem_dial(s,cp))
#define modem_answer(cp)          (ENDL,modem_answer(cp))
#define modem_hangup(cp)          (ENDL,modem_hangup(cp))
#define modem_online(cp)          (ENDL,modem_online(cp))
#define modem_repeat(cp)          (ENDL,modem_repeat(cp))
#define modem_speaker(x,cp)       (ENDL,modem_speaker(x,cp))
#define modem_echo(x,cp)          (ENDL,modem_echo(x,cp))
#define modem_word_reply(x,cp)    (ENDL,modem_word_reply(x,cp))
#define modem_extend_reply(x,cp)  (ENDL,modem_extend_reply(x,cp))
#define modem_duplex(x,cp)        (ENDL,modem_duplex(x,cp))
#define modem_quiet(x,cp)         (ENDL,modem_quiet(x,cp))

/*-------------------- current modem status macros -------------------------*/
#define is_dcd(cp)                (ENDL,is_dcd(cp))
#define is_cts(cp)                (ENDL,is_cts(cp))
#define is_dsr(cp)                (ENDL,is_dsr(cp))
#define is_ri(cp)                 (ENDL,is_ri(cp))

/*-------------------- static modem status macros --------------------------*/
#define clear_mstatus(cp)         (ENDL,clear_mstatus(cp))
#define is_sdcd(cp)               (ENDL,is_sdcd(cp))
#define is_scts(cp)               (ENDL,is_scts(cp))
#define is_sdsr(cp)               (ENDL,is_sdsr(cp))
#define is_sri(cp)                (ENDL,is_sri(cp))

#define is_sddcd(cp)              (ENDL,is_sddcd(cp))
#define is_sdcts(cp)              (ENDL,is_sdcts(cp))
#define is_sddsr(cp)              (ENDL,is_sddsr(cp))
#define is_sdri(cp)               (ENDL,is_sdri(cp))

/*-------------------- current line status macros --------------------------*/
#define is_overrun_err(cp)        (ENDL,is_overrun_err(cp))
#define is_parity_err(cp)         (ENDL,is_parity_err(cp))
#define is_framing_err(cp)        (ENDL,is_framing_err(cp))
#define is_break(cp)              (ENDL,is_break(cp))

/*-------------------- static line status macros ---------------------------*/
#define clear_lstatus(cp)         (ENDL,clear_lstatus(cp))
#define is_soverrun_err(cp)       (ENDL,is_soverrun_err(cp))
#define is_sparity_err(cp)        (ENDL,is_sparity_err(cp))
#define is_sframing_err(cp)       (ENDL,is_sframing_err(cp))
#define is_sbreak(cp)             (ENDL,is_sbreak(cp))

/*------------------ current modem control macros --------------------------*/
#define is_dtr(cp)                (ENDL,is_dtr(cp))
#define is_rts(cp)                (ENDL,is_rts(cp))
#define is_out1(cp)               (ENDL,is_out1(cp))
#define is_out2(cp)               (ENDL,is_out2(cp))
#define is_loop(cp)               (ENDL,is_loop(cp))


/*------------------------- en_main.c prototypes ---------------------------*/

#define com_vect_init(fp, cp)             (ENDL,com_vect_init(fp, cp))
#define com_port_create(a,b,c,d,e,f,g,cp) (ENDL,com_port_create(a,b,c,d,e,f,g,cp))
#define com_port_init(a,b,c,d,cp)         (ENDL,com_port_init(a,b,c,d,cp))
#define com_port_destroy(cp)              (ENDL,com_port_destroy(cp))
#define com_clear_que(a,cp)               (ENDL,com_clear_que(a,cp))
#define com_getc(cp)                      (ENDL,com_getc(cp))
#define com_putc(a,cp)                    (ENDL,com_putc(a,cp))
#define prime_tx(cp)                      (ENDL,prime_tx(cp))
#define force_tx(a,cp)                    (ENDL,force_tx(a,cp))
#define com_puts(a,cp)                    (ENDL,com_puts(a,cp))
#define check_rts(cp)                     (ENDL,check_rts(cp))
#define com_irq_ctrl(a,b,cp)              (ENDL,com_irq_ctrl(a,b,cp))
#define com_232_ctrl(a,b,cp)              (ENDL,com_232_ctrl(a,b,cp))
#define read_regs(a,cp)                   (ENDL,read_regs(a,cp))
#define write_regs(a,cp)                  (ENDL,write_regs(a,cp))

/*------------------------- en_supp.c prototypes ---------------------------*/
#define com_getc_qty(a,b,cp)              (ENDL,com_getc_qty(a,b,cp))
#define com_gets(a,b,c,cp)                (ENDL,com_gets(a,b,c,cp))
#define check_xon(cp)                     (ENDL,check_xon(cp))
#define com_putc1(a,cp)                   (ENDL,com_putc1(a,cp))
#define com_putc_qty(a,b,cp)              (ENDL,com_putc_qty(a,b,cp))
#define send_break(a,cp)                  (ENDL,send_break(a,cp))
#define set_xon_flow(a,b,c,d,e,cp)        (ENDL,set_xon_flow(a,b,c,d,e,cp))
#define set_dcd_flow(a,cp)                (ENDL,set_dcd_flow(a,cp))
#define set_dsr_flow(a,cp)                (ENDL,set_dsr_flow(a,cp))
#define suspend(a)                        (ENDL,suspend(a))
#define wait_for_rx(a,b,cp)               (ENDL,wait_for_rx(a,b,cp))
#define wait_for_no_rx(a,cp)              (ENDL,wait_for_no_rx(a,cp))
#define modem_cmd(a,b,c,cp)               (ENDL,modem_cmd(a,b,c,cp))
#define com_fifo_ctrl(a,b,cp)             (ENDL,com_fifo_ctrl(a,b,cp))
#define com_fifo_trigger(a,cp)            (ENDL,com_fifo_trigger(a,cp))

/*------------------------- en_supp.c prototypes ---------------------------*/
#define encrypt_msg(a,b)                  (ENDL,encrypt_msg(a,b))
#define calc_crc(a,b)                     (ENDL,calc_crc(a,b))
#define fmt_msg(a,b,c)                    (ENDL,fmt_msg(a,b,c))
#define defmt_msg(a,b)                    (ENDL,defmt_msg(a,b))
#define get_msg(a,b)                      (ENDL,get_msg(a,b))
#define mk_crc_tbl(a,b,c)                 (ENDL,mk_crc_tbl(a,b,c))
#define gen_crc(a,b,c)                    (ENDL,gen_crc(a,b,c))
#define gen_crc_rev(a,b,c)                (ENDL,gen_crc_rev(a,b,c))

/*-------------------------- en_kbd.c prototypes ---------------------------*/
#ifndef WN_POPUP
#define init_ctrlc_hdlr()                 (ENDL,init_ctrlc_hdlr())
#define end_ctrlc_hdlr()                  (ENDL,end_ctrlc_hdlr())
#define init_clock(a)                     (ENDL,init_clock(a))
#define end_clock()                       (ENDL,end_clock())
#define clock_speed(a)                    (ENDL,clock_speed(a))
#define tone(a,b)                         (ENDL,tone(a,b))
#define sound_off()                       (ENDL,sound_off())
#define set_idle_func(a)                  (ENDL,set_idle_func(a))
#endif

#endif /* SOURCE_TRACE */
#endif /* __EN_DBG_H */

/**** END OF FILE ****/
